'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _redux = require('redux');

var _run = require('@cycle/run');

var _reduxCycles = require('redux-cycles');

var _http = require('@cycle/http');

var _reducer = require('./reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _cycles = require('./cycles');

var _cycles2 = _interopRequireDefault(_cycles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (actionData) {
  var initialState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var extraReducers = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var extraMiddlewares = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

  var cycleMiddleware = (0, _reduxCycles.createCycleMiddleware)();

  var middewares = (0, _ramda.append)(cycleMiddleware, extraMiddlewares);

  var isArr = isDataArray(actionData);

  var exReducerKeys = Object.keys(extraReducers);

  if (exReducerKeys.length > 0 && !isArr) throw new Error('A name must be provided for the default reducer.');

  var reducers = !isArr ? (0, _reducer2.default)(actionData) : (0, _redux.combineReducers)(Object.assign({}, (0, _ramda.fromPairs)(Object.keys(actionData).map(function (r) {
    return [r, (0, _reducer2.default)(actionData[r])];
  })), extraReducers));

  var store = (0, _redux.createStore)(reducers, initialState, (0, _redux.compose)(_redux.applyMiddleware.apply(undefined, _toConsumableArray(middewares)), process && process.env && process.env.NODE_ENV === 'development' && window.devToolsExtension ? window.devToolsExtension() : function (f) {
    return f;
  }));

  (0, _run.run)(_reduxCycles.combineCycles.apply(undefined, _toConsumableArray((0, _cycles2.default)(actionData))), {
    ACTION: cycleMiddleware.makeActionDriver(),
    HTTP: (0, _http.makeHTTPDriver)()
  });

  return store;
};

var isDataArray = function isDataArray(d) {
  return (0, _ramda.is)(Object, d) && Object.keys(d).every(function (x) {
    return (0, _ramda.is)(Object, d[x]) && !(0, _ramda.isEmpty)(d[x]) && Object.keys(d[x]).every(function (y) {
      return (0, _ramda.is)(Object, d[x][y]);
    });
  });
};